package jr.eecs1022.tonegenerator;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.SeekBar;

public class ToneGenerator extends AppCompatActivity implements SeekBar.OnSeekBarChangeListener
{
    private ToneEmitter toneEmitter = null;

    public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser)
    {
        if (toneEmitter != null)
        {
            System.out.println("onPress called with " + progress);
        }
    }

    public void onStartTrackingTouch(SeekBar seekBar)
    {
    }

    public void onStopTrackingTouch(SeekBar seekBar)
    {
    }

    private void setFrequency(double frequency)
    {
        System.out.println("setFrequency called with " + frequency);
    }

    private void setAmplitude(double amplitude)
    {
        System.out.println("setAmplitude called with " + amplitude);
    }


    @Override
    protected void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tone_generator);

        SeekBar seekbar = (SeekBar) findViewById(R.id.changeAmplitude);
        seekbar.setOnSeekBarChangeListener(this);
        seekbar = (SeekBar) findViewById(R.id.changeFrequency);
        seekbar.setOnSeekBarChangeListener(this);
    }

    @Override
    public void onResume()
    {
        super.onResume();
        toneEmitter = new ToneEmitter();
        this.setAmplitude(0.0);
        this.setFrequency(ToneEmitter.NOTE_C);
        SeekBar seekBar = (SeekBar) findViewById(R.id.changeAmplitude);
        seekBar.setProgress(0);
        seekBar = (SeekBar) findViewById(R.id.changeFrequency);
        seekBar.setProgress(0);
    }

    @Override
    public void onPause()
    {
        toneEmitter.shutdown();
        toneEmitter = null;
        super.onPause();
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_tone_generator, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings)
        {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
